Package org.opensaml.xmlsec.impl

# Class BasicSignatureSigningConfiguration

java.lang.Object
org.opensaml.xmlsec.impl.BasicAlgorithmPolicyConfiguration
org.opensaml.xmlsec.impl.BasicSignatureSigningConfiguration

All Implemented Interfaces:
  `AlgorithmPolicyConfiguration`, `SignatureSigningConfiguration`

public class BasicSignatureSigningConfiguration extends BasicAlgorithmPolicyConfiguration implements SignatureSigningConfiguration
Basic implementation of `SignatureSigningConfiguration`.

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.opensaml.xmlsec.AlgorithmPolicyConfiguration

`AlgorithmPolicyConfiguration.Precedence`

## Field Summary

Fields
Modifier and Type
Field
Description
`private NamedKeyInfoGeneratorManager`
`keyInfoGeneratorManager`
Manager for named KeyInfoGenerator instances.
`private List<String>`
`signatureAlgorithms`
Signature method algorithm URIs.
`private String`
`signatureCanonicalization`
Signature canonicalization algorithm URI.
`private Integer`
`signatureHMACOutputLength`
Signature HMAC output length.
`private String`
`signatureReferenceCanonicalizationAlgorithm`
The signature reference canonicalization transform algorithm.
`private List<String>`
`signatureReferenceDigestMethods`
Digest method algorithm URIs.
`private List<Credential>`
`signingCredentials`
Signing credentials.

### Fields inherited from class org.opensaml.xmlsec.impl.BasicAlgorithmPolicyConfiguration

`DEFAULT_PRECEDENCE`

## Constructor Summary

Constructors
Constructor
Description
`BasicSignatureSigningConfiguration()`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`NamedKeyInfoGeneratorManager`
`getKeyInfoGeneratorManager()`
Get the manager for named KeyInfoGenerator instances.
`List<String>`
`getSignatureAlgorithms()`
Get the list of preferred signature algorithm URIs, in preference order.
`String`
`getSignatureCanonicalizationAlgorithm()`
Get a canonicalization algorithm URI suitable for use as a Signature CanonicalizationMethod value.
`Integer`
`getSignatureHMACOutputLength()`
Get the value to be used as the Signature SignatureMethod HMACOutputLength value, used only when signing with an HMAC algorithm.
`String`
`getSignatureReferenceCanonicalizationAlgorithm()`
Get a canonicalization algorithm URI suitable for use as a Signature Reference Transform value.
`List<String>`
`getSignatureReferenceDigestMethods()`
Get the list of digest method algorithm URIs suitable for use as a Signature Reference DigestMethod value, in preference order.
`List<Credential>`
`getSigningCredentials()`
Get the list of signing credentials to use when signing, in preference order.
`BasicSignatureSigningConfiguration`
`setKeyInfoGeneratorManager(NamedKeyInfoGeneratorManager keyInfoManager)`
Set the manager for named KeyInfoGenerator instances.
`BasicSignatureSigningConfiguration`
`setSignatureAlgorithms(List<String> algorithms)`
Set the signature algorithms to use when signing.
`BasicSignatureSigningConfiguration`
`setSignatureCanonicalizationAlgorithm(String algorithmURI)`
Set a canonicalization algorithm URI suitable for use as a Signature CanonicalizationMethod value.
`BasicSignatureSigningConfiguration`
`setSignatureHMACOutputLength(Integer length)`
Set the value to be used as the Signature SignatureMethod HMACOutputLength value, used only when signing with an HMAC algorithm.
`BasicSignatureSigningConfiguration`
`setSignatureReferenceCanonicalizationAlgorithm(String uri)`
Get a canonicalization algorithm URI suitable for use as a Signature Reference Transform value.
`BasicSignatureSigningConfiguration`
`setSignatureReferenceDigestMethods(List<String> algorithms)`
Set a digest method algorithm URI suitable for use as a Signature Reference DigestMethod value.
`BasicSignatureSigningConfiguration`
`setSigningCredentials(List<Credential> credentials)`
Set the signing credentials to use when signing.

### Methods inherited from class org.opensaml.xmlsec.impl.BasicAlgorithmPolicyConfiguration

`getExcludedAlgorithms, getIncludedAlgorithms, getIncludeExcludePrecedence, isExcludeMerge, isIncludeMerge, setExcludedAlgorithms, setExcludeMerge, setIncludedAlgorithms, setIncludeExcludePrecedence, setIncludeMerge`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.opensaml.xmlsec.AlgorithmPolicyConfiguration

`getExcludedAlgorithms, getIncludedAlgorithms, getIncludeExcludePrecedence, isExcludeMerge, isIncludeMerge`

## Field Details

### signingCredentials

@Nonnull private List<Credential> signingCredentials
Signing credentials.

### signatureAlgorithms

@Nonnull private List<String> signatureAlgorithms
Signature method algorithm URIs.

### signatureReferenceDigestMethods

@Nonnull private List<String> signatureReferenceDigestMethods
Digest method algorithm URIs.

### signatureReferenceCanonicalizationAlgorithm

@Nullable private String signatureReferenceCanonicalizationAlgorithm
The signature reference canonicalization transform algorithm.

### signatureCanonicalization

@Nullable private String signatureCanonicalization
Signature canonicalization algorithm URI.

### signatureHMACOutputLength

@Nullable private Integer signatureHMACOutputLength
Signature HMAC output length.

### keyInfoGeneratorManager

@Nullable private NamedKeyInfoGeneratorManager keyInfoGeneratorManager
Manager for named KeyInfoGenerator instances.

## Constructor Details

### BasicSignatureSigningConfiguration

public BasicSignatureSigningConfiguration()
Constructor.

## Method Details

### getSigningCredentials

@Nonnull @Unmodifiable @NotLive public List<Credential> getSigningCredentials()
Get the list of signing credentials to use when signing, in preference order.

Specified by:
  `getSigningCredentials` in interface `SignatureSigningConfiguration`
Returns:
  the list of signing credentials, may be empty

### setSigningCredentials

@Nonnull public BasicSignatureSigningConfiguration setSigningCredentials(@Nullable List<Credential> credentials)
Set the signing credentials to use when signing.

Parameters:
  `credentials` - the list of signing credentials
Returns:
  this object

### getSignatureAlgorithms

@Nonnull @Unmodifiable @NotLive public List<String> getSignatureAlgorithms()
Get the list of preferred signature algorithm URIs, in preference order.

Specified by:
  `getSignatureAlgorithms` in interface `SignatureSigningConfiguration`
Returns:
  the list of algorithm URIs, may be empty

### setSignatureAlgorithms

@Nonnull public BasicSignatureSigningConfiguration setSignatureAlgorithms(@Nullable List<String> algorithms)
Set the signature algorithms to use when signing.

Parameters:
  `algorithms` - the list of signature algorithms
Returns:
  this object

### getSignatureReferenceDigestMethods

@Nonnull @Unmodifiable @NotLive public List<String> getSignatureReferenceDigestMethods()
Get the list of digest method algorithm URIs suitable for use as a Signature Reference DigestMethod value, in preference order.

Specified by:
  `getSignatureReferenceDigestMethods` in interface `SignatureSigningConfiguration`
Returns:
  a digest method algorithm URI

### setSignatureReferenceDigestMethods

@Nonnull public BasicSignatureSigningConfiguration setSignatureReferenceDigestMethods(@Nullable List<String> algorithms)
Set a digest method algorithm URI suitable for use as a Signature Reference DigestMethod value.

Parameters:
  `algorithms` - a list of digest method algorithm URIs
Returns:
  this object

### getSignatureReferenceCanonicalizationAlgorithm

@Nullable public String getSignatureReferenceCanonicalizationAlgorithm()
Get a canonicalization algorithm URI suitable for use as a Signature Reference Transform value.

Specified by:
  `getSignatureReferenceCanonicalizationAlgorithm` in interface `SignatureSigningConfiguration`
Returns:
  a digest method algorithm URI

### setSignatureReferenceCanonicalizationAlgorithm

@Nonnull public BasicSignatureSigningConfiguration setSignatureReferenceCanonicalizationAlgorithm(@Nullable String uri)
Get a canonicalization algorithm URI suitable for use as a Signature Reference Transform value.

Parameters:
  `uri` - a canonicalization algorithm URI
Returns:
  this object

### getSignatureCanonicalizationAlgorithm

@Nullable public String getSignatureCanonicalizationAlgorithm()
Get a canonicalization algorithm URI suitable for use as a Signature CanonicalizationMethod value.

Specified by:
  `getSignatureCanonicalizationAlgorithm` in interface `SignatureSigningConfiguration`
Returns:
  a canonicalization algorithm URI

### setSignatureCanonicalizationAlgorithm

@Nonnull public BasicSignatureSigningConfiguration setSignatureCanonicalizationAlgorithm(@Nullable String algorithmURI)
Set a canonicalization algorithm URI suitable for use as a Signature CanonicalizationMethod value.

Parameters:
  `algorithmURI` - a canonicalization algorithm URI
Returns:
  this object

### getSignatureHMACOutputLength

@Nullable public Integer getSignatureHMACOutputLength()
Get the value to be used as the Signature SignatureMethod HMACOutputLength value, used only when signing with an HMAC algorithm. This value is optional when using HMAC.

Specified by:
  `getSignatureHMACOutputLength` in interface `SignatureSigningConfiguration`
Returns:
  the configured HMAC output length value

### setSignatureHMACOutputLength

@Nonnull public BasicSignatureSigningConfiguration setSignatureHMACOutputLength(@Nullable Integer length)
Set the value to be used as the Signature SignatureMethod HMACOutputLength value, used only when signing with an HMAC algorithm. This value is optional when using HMAC.

Parameters:
  `length` - the HMAC output length value to use when performing HMAC signing (may be null)
Returns:
  this object

### getKeyInfoGeneratorManager

@Nullable public NamedKeyInfoGeneratorManager getKeyInfoGeneratorManager()
Get the manager for named KeyInfoGenerator instances.

Specified by:
  `getKeyInfoGeneratorManager` in interface `SignatureSigningConfiguration`
Returns:
  the KeyInfoGenerator manager, or null if none is configured

### setKeyInfoGeneratorManager

@Nonnull public BasicSignatureSigningConfiguration setKeyInfoGeneratorManager(@Nullable NamedKeyInfoGeneratorManager keyInfoManager)
Set the manager for named KeyInfoGenerator instances.

Parameters:
  `keyInfoManager` - the KeyInfoGenerator manager to use
Returns:
  this object